local AddName, AddonTable = ...
local L = AddonTable.L

------------------------------
--		Options Equates		--
------------------------------
local Both, Enhanced, Base, MainHand, OffHand = 3, 1, 2, 1, 2
local SameLevel, BossLevel, Auto = 1, 2, 3

----------------------------------
--		Text Return Formats		--
----------------------------------
local Miss_Chance_Format = { "%.2f%%", "%.2f%%", "%.2f/%.2f%%", }

------------------------------
--		Global Updater		--
------------------------------

function AddonTable.MeleeUpdate()

 	AddonTable.targetLevel = AddonTable.playerLevel + 3
	
	-- Miss chance
	AddonTable.meleeSameLevel = 0
	AddonTable.meleeBossLevel = 0
	local mainBase, mainMod, offBase, offMod = UnitAttackBothHands("player")
	local levelDefense = AddonTable.playerLevel * 5
	local bossDefense = (AddonTable.playerLevel + 3) * 5
	local mWeaponSkill = (mainBase + mainMod)
	--local shieldEquipped = IsEquippedItemType("Shields")
	local mhID = GetInventoryItemID("player", 16)
	local ohID = GetInventoryItemID("player", 17)
	local itemType, itemSubtype, classId, subId = 0, 0, 0, 0
	local hitChance = GetHitModifier("player")

	if hitChance == nil then
		hitChance = 0
	end
		
	AddonTable.mWepSkill = mWeaponSkill
	if AddonTable.mWeaponSkill < 300 then 
		mWepSkill = 300 
	end				

	local meleeSkillDiff = levelDefense - AddonTable.mWeaponSkill
	local bossSkillDiff = bossDefense - AddonTable.mWeaponSkill
	local bossSkillMod = bossDefense - mWepSkill
	AddonTable.missMod = 0
	local missModboss = 0	

	missModboss = AddonTable.meleeBossLevel
	
	if ohID then 
		_,_,_,_,_,itemType, itemSubtype, _, _, _, _, classId, subId = GetItemInfo(ohID)
	end
	

	if (mhID and (ohID and classId == AddonTable.weaponTag)) or (not mhID and (ohID and classId == AddonTable.weaponTag)) then
		if (classFilename == "WARRIOR") or (classFilename == "ROGUE") or (classFilename == "HUNTER") then
			if meleeSkillDiff > 10 then
				AddonTable.meleeSameLevel = (26 + ((meleeSkillDiff - 10) * 0.4))
				AddonTable.meleeSameLevel = AddonTable.meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				AddonTable.meleeSameLevel = (24 + ((meleeSkillDiff) * 0.1))
				AddonTable.meleeSameLevel = AddonTable.meleeSameLevel - hitChance		
			end
			
			if bossSkillDiff > 10 then
				AddonTable.meleeBossLevel = (26 + ((bossSkillDiff - 10) * 0.4))
				AddonTable.meleeBossLevel = AddonTable.meleeBossLevel - hitChance
				AddonTable.missMod = (26 + ((bossSkillMod - 10) * 0.4))
				AddonTable.missMod = AddonTable.missMod - hitChance
			elseif bossSkillDiff <= 10 then
				AddonTable.meleeBossLevel = (24 + ((bossSkillDiff) * 0.1))
				AddonTable.meleeBossLevel = AddonTable.meleeBossLevel - hitChance   	
				AddonTable.missMod = (26 + ((bossSkillMod - 10) * 0.4))
				AddonTable.missMod = AddonTable.missMod - hitChance				
			end
		end	
		
	elseif (mhID and (ohID and classId ~= AddonTable.weaponTag)) or (not mhID and (classId ~= AddonTable.weaponTag)) or (mhID and not ohID) or (not mhID and not ohID) then
		if shapeshitCheck() then
			AddonTable.meleeSameLevel = 5 - hitChance
			AddonTable.meleeBossLevel = 9 - hitChance
		else
			if meleeSkillDiff > 10 then
				AddonTable.meleeSameLevel = (7 + ((meleeSkillDiff - 10) * 0.4))
				AddonTable.meleeSameLevel = AddonTable.meleeSameLevel - hitChance
			elseif meleeSkillDiff <= 10 then
				AddonTable.meleeSameLevel = (5 + ((meleeSkillDiff) * 0.1))
				AddonTable.meleeSameLevel = AddonTable.meleeSameLevel - hitChance		
			end

			if bossSkillDiff > 10 then
				AddonTable.meleeBossLevel = (7 + ((bossSkillDiff - 10) * 0.4))
				AddonTable.meleeBossLevel = AddonTable.meleeBossLevel - hitChance  
				AddonTable.missMod = (7 + ((bossSkillMod - 10) * 0.4))
				AddonTable.missMod = AddonTable.missMod - hitChance					
			elseif bossSkillDiff <= 10 then
				AddonTable.meleeBossLevel = (5 + ((bossSkillDiff) * 0.1))
				AddonTable.meleeBossLevel = AddonTable.meleeBossLevel - hitChance   	
				AddonTable.missMod = (5 + ((bossSkillMod - 10) * 0.1))
				AddonTable.missMod = AddonTable.missMod - hitChance					
			end		
		end	
		
	end
	
	if AddonTable.meleeSameLevel < 0 then
		AddonTable.meleeSameLevel = 0
	elseif AddonTable.meleeSameLevel > 100 then
		AddonTable.meleeSameLevel = 100
	end
	if AddonTable.meleeBossLevel < 0 then
		AddonTable.meleeBossLevel = 0
	elseif AddonTable.meleeBossLevel > 100 then
		AddonTable.meleeBossLevel = 100
	end	

end

-- Attack Power
function AddonTable.FunctionList.AP(HUD, data, options, ...)

	local base, posBuff, negBuff = UnitAttackPower("player")
	local effectiveAP = base + posBuff + negBuff
	local debuffColor = ""
	
	if negBuff > 0 then
		debuffColor = "|cffC41E3A"
	end
	
	HUD:UpdateText(data, debuffColor .. effectiveAP)
end	
------------------------------------------------

-- Damage
function AddonTable.FunctionList.DMG(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Main_Off_Auto
	local lowDmg, hiDmg, offlowDmg, offhiDmg, posBuff, negBuff, percentmod = UnitDamage("player")
	local ohID = GetInventoryItemID("player", 17)
	local maxDamage = hiDmg
	local maxDamageOH = offhiDmg
	local debuffColor = ""
	local returnText
	local classId = 0
	
	if ohID then 
		_,_,_,_,_,_, _, _, _, _, _, classId = GetItemInfo(ohID)
	end	

	if options.Display_Average then
		maxDamage = (hiDmg + lowDmg) / 2
		maxDamageOH = (offhiDmg + offlowDmg) / 2
	end
	
	local maxDamageAlt = maxDamageOH
	
	if (ohID and classId == AddonTable.weaponTag) then
		maxDamageOH = "/" .. math.floor(maxDamageOH)
	else 
		maxDamageOH = ""
	end	
	
	 if negBuff < 0 then		
		debuffColor = "|cffC41E3A"
	end

	if AddonTable.Band(EB, MainHand) then
		returnText = debuffColor .. math.floor(maxDamage)
	end
	if  AddonTable.Band(EB, OffHand) then
		returnText = math.floor(maxDamageAlt)
	end
	if AddonTable.Band(EB, Auto) then
		returnText = math.floor(maxDamage) .. maxDamageOH
	end
	
	if returnText == nil then
		returnText = ""
	end	

	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Defense
function AddonTable.FunctionList.DefenseStat(HUD, data, options, ...)

	local baseDefense = 0
	local bonusDefense = 0
	local DefGearIndex = 0		
	local DefGear = GetNumSkillLines()
	local DefHeader = nil
		
	for i = 1, DefGear do
		local DefName = select(1, GetSkillLineInfo(i))
		local headerCheck = select(2, GetSkillLineInfo(i))
		if headerCheck ~= nil and headerCheck then
			DefHeader = DefName;
		else
			if (DefHeader == AddonTable.headerLoc) and (DefName == AddonTable.defenseLoc) then
				DefGearIndex = i
				break
			end
		end	
	end
	if (DefGearIndex > 0) then
		baseDefense = select(4, GetSkillLineInfo(DefGearIndex))
		bonusDefense = select(6, GetSkillLineInfo(DefGearIndex))
	end
	
	HUD:UpdateText(data, format("%.0f", (baseDefense + bonusDefense)))
end	
------------------------------------------------

-- Armor
function AddonTable.FunctionList.Armor(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Enhanced_Base
	local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
	local returnText
	local debuffColor = ""
	
	if negBuff < 0 then
		debuffColor = "|cffC41E3A"
	end	
	
	if AddonTable.Band(EB, Enhanced) then
		returnText = debuffColor .. effectiveArmor
	end
	if  AddonTable.Band(EB, Base) then
		returnText = base
	end
	if  AddonTable.Band(EB, Both) then
		returnText = debuffColor .. effectiveArmor .. "/" .. base
	end	
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Mitigation
function AddonTable.FunctionList.Mitigation(HUD, data, options, ...)

	local debuffColor = ""
	local base, effectiveArmor, armor, posBuff, negBuff = UnitArmor("player")
	local armorReduction = effectiveArmor/((85 * AddonTable.playerLevel) + 400)
	armorReduction = 100 * (armorReduction/(armorReduction + 1))
	
	if negBuff < 0 then
		debuffColor = "|cffC41E3A"
	end
	
	if armorReduction > 100 then
		armorReduction = 100
		debuffColor = "|cff71FFC9"
	elseif armorReduction < 0 then
		armorReduction = 0
		debuffColor = "|cffC41E3A"
	end

	HUD:UpdateText(data, debuffColor ..  ("%.0f%%"):format(armorReduction))
end
------------------------------------------------

-- Critical
function AddonTable.FunctionList.Crit(HUD, data, options, ...)

	local critChance = GetCritChance("player")

	HUD:UpdateText(data, ("%.2f%%"):format(critChance))
end
------------------------------------------------

-- Hit
function AddonTable.FunctionList.Hit(HUD, data, options, ...)

	local hitChance = GetHitModifier("player")

	if hitChance == nil then
		hitChance = 0
	end
	
	HUD:UpdateText(data, hitChance .. "%")
end
------------------------------------------------

-- Attack Speed
function AddonTable.FunctionList.WeaponSpeed(HUD, data, options, ...)

	local EB, percentStat, ratingStat = options.Main_Off_Auto
	local mainSpeed, offSpeed = UnitAttackSpeed("player")
	local returnText
	
	if offSpeed == nil then
		offSpeed = ""
	else
		offSpeed = ("%.1f"):format(offSpeed)
	end
	
	if AddonTable.Band(EB, MainHand) then
		returnText = mainSpeed
	end
	if  AddonTable.Band(EB, OffHand) then
		returnText = offSpeed
	end
	if  AddonTable.Band(EB, Auto) then
		returnText = mainSpeed .. "/" .. offSpeed
	end	
	
	HUD:UpdateText(data, returnText)
end
------------------------------------------------

-- Miss chance
function AddonTable.FunctionList.MeleeMiss(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Level_Same_Boss
	local statFormat = Miss_Chance_Format[EB]

	if AddonTable.Band(EB, SameLevel) then
		enhancedStat = AddonTable.meleeSameLevel
	end
	if  AddonTable.Band(EB, BossLevel) then
		baseStat = AddonTable.meleeBossLevel
	end
	
	HUD:UpdateText(data, format(statFormat, enhancedStat and enhancedStat or baseStat, baseStat))
end
------------------------------------------------

-- Crit Cap
function AddonTable.FunctionList.CritCap(HUD, data, options, ...)

	local EB, enhancedStat, baseStat = options.Level_Same_Boss
	local mhID = GetInventoryItemID("player", 16)
	local ohID = GetInventoryItemID("player", 17)
	local itemType, itemSubtype, classId, subId = 0, 0, 0, 0
	local mainBase, mainMod, offBase, offMod = UnitAttackBothHands("player")
	local critChance = GetCritChance("player")
	local critCapColor = ""
	
	if ohID and classId == weaponTag then 
		AddonTable.mWepSkill = math.min((mainBase + mainMod), (offBase + offMod)) 
	end	
	
	local skillDiff = 315 - AddonTable.mWepSkill
	local critSupp = 4.8	
	local dodgeBoss = 5 + (skillDiff * 0.1)
	local glancingBoss = 40	
	local extraWeaponSkill = AddonTable.mWepSkill - 300	
	local mcritCap = 100 - AddonTable.missMod - dodgeBoss - glancingBoss + critSupp + (extraWeaponSkill * 0.04)
	
	if critChance > mcritCap then
		critCapColor = "|cffC41E3A"
	elseif critChance == mcritCap then
		critCapColor = "|cffFF7C0A"
	else
		critCapColor = "|cff00f26d"
	end	

	
	HUD:UpdateText(data, critCapColor .. ("%.1f%%"):format(mcritCap))
end
------------------------------------------------


-- Block
function AddonTable.FunctionList.Block(HUD, data, options, ...)

	local EB, percentStat, ratingStat = options.Percent_Rating
	local blockChance = GetBlockChance("player")
	
	HUD:UpdateText(data, format(statFormat, ("%.2f%%"):format(blockChance))
end
------------------------------------------------

-- Parry
function AddonTable.FunctionList.Parry(HUD, data, options, ...)

	local EB, percentStat, ratingStat = options.Percent_Rating
	local parryChance = GetParryChance("player")
	
	HUD:UpdateText(data, format(statFormat, ("%.2f%%"):format(parryChance))
end
------------------------------------------------

-- Dodge
function AddonTable.FunctionList.Dodge(HUD, data, options, ...)

	local EB, percentStat, ratingStat = options.Percent_Rating
	local dodgeChance = GetDodgeChance("player")
	
	HUD:UpdateText(data, format(statFormat, ("%.2f%%"):format(dodgeChance))
end
------------------------------------------------
